
#ifndef  __ETH_RAW_H__
#define  __ETH_RAW_H__


#include "eth_raw_listener.H"
#include "sinc.H"
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <linux/if_arp.h>
#include <string.h>
#include <netinet/in.h>

#include <string>


extern "C++" {
	using namespace std;
	namespace mhp {
		class TEthRaw {
			private:
				struct sockaddr_ll sa;
				string deviceName;
				unsigned char deviceMAC[ETH_ALEN];
				unsigned char allowedSourceMAC[ETH_ALEN];
				unsigned char destMAC[ETH_ALEN];
				unsigned char sourceMAC[ETH_ALEN];
				bool filter;
				int s;
				struct ifreq ifr;
				int ifindex;
				unsigned char sendBuffer[ETH_FRAME_LEN];
				unsigned char *sendP;
				int remainSendSize;
				unsigned char recvBuffer[ETH_FRAME_LEN];
				unsigned char *recvP;
				int remainRecvSize;
				unsigned char *ether_head;
				unsigned char *data;
				struct ethhdr *eh;
				TEthRawListener *listener;
				TSinc *sinc;
				void showMAC(ostream &c, unsigned char *mac);
			public:
				TEthRaw(TSinc &sinc, const string &deviceName = "", TEthRawListener *listener = NULL, unsigned char *allowedSourceMAC = NULL);
				~TEthRaw();
				void setDeviceName(const string &devinceName);
				void setListener(TEthRawListener *listener);
				void setAllowedSourceMAC(unsigned char *mac);
				bool connect();
				void send(unsigned char *destMAC, void *data, int size);
				int run();
				void disconnect();
		};
	}
}

#endif  // __ETH_RAW_H__
