

#ifndef  __PTY_H__
#define  __PTY_H__


#include <string>

#include "pty_listener.H"
#include "sinc.H"


#define  PTY_BUFFER_SIZE  1500


extern "C++" {
	using namespace std;
	namespace mhp {
		class TPty {
			private:
				int masterFd;
				string slaveName;
				TPtyListener *listener;
				unsigned char sendBuffer[PTY_BUFFER_SIZE];
				unsigned char *sendP;
				int remainSendSize;
				unsigned char recvBuffer[PTY_BUFFER_SIZE];
				unsigned char *recvP;
				int remainRecvSize;
				TSinc *sinc;
			public:
				TPty(TSinc &sinc, TPtyListener *listener = NULL);
				~TPty();
				void setListener(TPtyListener *listener);
				bool open();
				const string &getSlaveName();
				void send(void *data, int size);
				int run();
				void close();
		};
	}
}

#endif  // __PTY_H__
