

#include "sinc.H"


using namespace std;
using namespace mhp;


void TSinc::clear() { //limpio todos los descriptores de fichero
	FD_ZERO(&this->rfds);
	FD_ZERO(&this->wfds);
	FD_ZERO(&this->efds);
	FD_ZERO(&this->xrfds);
	FD_ZERO(&this->xwfds);
	FD_ZERO(&this->xefds);
	/* Wait up */
	this->tv.tv_sec = 0;
	this->tv.tv_usec = 0;
	this->max = 0;
}

TSinc::TSinc(void) {  //Constructor de la clase Tsincrono
	this->clear();
}

void TSinc::setSec(const int s) {  //indico los segundos que quiero (pongo las useg a 0
	this->sec = s;
	this->usec = 0;
}

void TSinc::setUsec(const int us) { //indico los usegundos que quiero (pongo las seg a 0
	this->sec = 0;
	this->usec = us;
}

int TSinc::wait() { //esta funcion es el select en si, con una llamada a la funcion de callback si fuese necesario (si existe)
	this->tv.tv_sec = this->sec;
	this->tv.tv_usec = this->usec;
	memcpy(&this->xrfds, &this->rfds, sizeof(this->rfds));
	memcpy(&this->xwfds, &this->wfds, sizeof(this->wfds));
	memcpy(&this->xefds, &this->efds, sizeof(this->efds));
	this->event = select(this->max, &this->xrfds, &this->xwfds, &this->xefds, &this->tv);
    return this->event;
}

int TSinc::noWait() { //esta funcion es el select en si, con una llamada a la funcion de callback si fuese necesario (si existe)
	this->tv.tv_sec = 0;
	this->tv.tv_usec = 0;
    memcpy(&this->xrfds, &this->rfds, sizeof(this->rfds));
    memcpy(&this->xwfds, &this->wfds, sizeof(this->wfds));
    memcpy(&this->xefds, &this->efds, sizeof(this->efds));
    this->event = select(this->max, &this->xrfds, &this->xwfds, &this->xefds, &this->tv);
    return this->event;
}

void TSinc::setRead(const int elfd) {  //se le pone un valor al read (recordar que maximo es el numero del descriptor de fichero mas alto+1)
	if (elfd < 0)
		return;
	FD_SET(elfd, &this->rfds);
	if (this->max <= elfd)
		this->max = elfd + 1;
}

void TSinc::setWrite(const int elfd) { //se le pone un valor al write (recordar que maximo es el numero del descriptor de fichero mas alto+1)
	if (elfd < 0)
		return;
	FD_SET(elfd, &this->wfds);
	if (this->max <= elfd)
		this->max = elfd + 1;
}

void TSinc::setExcept(const int elfd) { //se le pone un valor a la excepcion (recordar que maximo es el numero del descriptor de fichero mas alto+1)
	if (elfd < 0)
		return;
	FD_SET(elfd, &this->efds);
	if (this->max <= elfd)
		this->max = elfd + 1;
}

void TSinc::clrRead(const int elfd) { //limpio el descriptor de fichero del read
	if (elfd < 0)
		return;
	FD_CLR(elfd, &this->rfds);
}

void TSinc::clrWrite(const int elfd) { //limpio el descriptor de fichero del write
	if (elfd < 0)
		return;
	FD_CLR(elfd, &this->wfds);
}

void TSinc::clrExcept(const int elfd) { //limpio el descriptor de fichero de la excepcion
	if (elfd < 0)
		return;
	FD_CLR(elfd, &this->efds);
}

bool TSinc::isRead(const int elfd) { //ISSET
	if (elfd < 0)
		return false;
	return FD_ISSET(elfd, &this->xrfds);
}

bool TSinc::isWrite(const int elfd) {
	if (elfd < 0)
		return false;
	return FD_ISSET(elfd, &this->xwfds);
}

bool TSinc::isExcept(const int elfd) {
	if (elfd < 0)
		return false;
	return FD_ISSET(elfd, &this->xefds);
}

