

#ifndef  __SOE_H__
#define  __SOE_H__


#include "sinc.H"
#include "pty.H"
#include "pty_listener.H"
#include "eth_raw.H"
#include "eth_raw_listener.H"
#include <linux/if_ether.h>


extern "C++" {
	using namespace std;
	namespace mhp {
		class TSoe : public TPtyListener, public TEthRawListener {
			private:
				TSinc sinc;
				TPty pty;
				TEthRaw ethRaw;
				unsigned char otherSideMAC[ETH_ALEN];
				void savePtsPath(const string &path);
			public:
				TSoe(const string &deviceName, unsigned char *otherSideMAC);
				~TSoe();
				string getStringFromBuffer(void *data, int size);
				void ethRawPacketReceived(void *data, int size);
				void ethRawPacketSent(void *data);
				void ptyDataReceived(void *data, int size);
				void ptyDataSent(void *data);
				int run();
				void mainLoop();
		};
	}
}


#endif  // __SOE_H__
